//
//  LDScrollViewViewController.m
//  LDRefreshHeader
//
//  Created by Daredos on 16/5/19.
//  Copyright © 2016年 LiangDaHong. All rights reserved.
//

#import "LDScrollViewViewController.h"
#import "LDRefresh.h"

@interface LDScrollViewViewController ()

@property (strong, nonatomic) UIScrollView *scrollView;

@end

@implementation LDScrollViewViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor whiteColor];
    
    // Do any additional setup after loading the view.
    
    [self.view addSubview:self.scrollView];
    
    self.scrollView.header = [LDRefreshHeader refreshHeaderWithBeginRefreshingBlock:^(UIScrollView *scrollView) {
        
        [self.scrollView.header beginRefreshing];
        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(2 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
            [self.scrollView.header endRefreshing];
        });
    }];
    
    // 开启刷新
    [self.scrollView.header beginRefreshing];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

- (UIScrollView *)scrollView {

    if (!_scrollView) {
        _scrollView = [[UIScrollView alloc] initWithFrame:self.view.bounds];
        _scrollView.contentSize = CGSizeMake(0, self.view.frame.size.height+10);
    }
    return _scrollView;
}
@end
