//
//  LDRefreshHeader.m
//
//  Created by Daredos on 16/5/19.
//  Copyright © 2016年 coderyi. All rights reserved.
//
//  最初版本，有许多需要完善的,我会慢慢一一完善!!

//   (QQ)   2244784466
//  (博客)  http://www.cnblogs.com/dahongliang/
//  (github)https://github.com/asiosldh/LDRefresh.git

#import "LDRefreshHeader.h"

#define kh (-1000.00f)

#ifndef    weakify
#if __has_feature(objc_arc)

#define weakify( x ) \
_Pragma("clang diagnostic push") \
_Pragma("clang diagnostic ignored \"-Wshadow\"") \
autoreleasepool{} __weak __typeof__(x) __weak_##x##__ = x; \
_Pragma("clang diagnostic pop")

#else

#define weakify( x ) \
_Pragma("clang diagnostic push") \
_Pragma("clang diagnostic ignored \"-Wshadow\"") \
autoreleasepool{} __block __typeof__(x) __block_##x##__ = x; \
_Pragma("clang diagnostic pop")

#endif
#endif

#ifndef    strongify
#if __has_feature(objc_arc)

#define strongify( x ) \
_Pragma("clang diagnostic push") \
_Pragma("clang diagnostic ignored \"-Wshadow\"") \
try{} @finally{} __typeof__(x) x = __weak_##x##__; \
_Pragma("clang diagnostic pop")

#else

#define strongify( x ) \
_Pragma("clang diagnostic push") \
_Pragma("clang diagnostic ignored \"-Wshadow\"") \
try{} @finally{} __typeof__(x) x = __block_##x##__; \
_Pragma("clang diagnostic pop")

#endif
#endif

@interface LDRefreshHeader ()
@property (strong, nonatomic) UIView   *backView;
@property (strong, nonatomic) UILabel  *label;
@property (copy,   nonatomic) NSString *reloadString;
@property (assign, nonatomic, getter=isReload) BOOL reload;

@end

@implementation LDRefreshHeader

- (instancetype)init
{
    self = [super init];
    if (self) {
        self.reloadString = @"⇣ 继续下拉刷新";
    }
    return self;
}

+ (instancetype)refreshHeaderWithBeginRefreshingBlock:(LDRefreshActionBlock)beginRefreshingBlock {
    
    LDRefreshHeader *refreshHeader = [LDRefreshHeader new];
    refreshHeader.beginRefreshingBlock = beginRefreshingBlock;
    return refreshHeader;
}

- (void)setScrollView:(UIScrollView *)scrollView {
    
    _scrollView = scrollView;
    
    if (self.backView) {
        [self.backView removeFromSuperview];
        [self.scrollView removeObserver:self forKeyPath:@"contentOffset"];
    }
    
    self.backView = [[UIView alloc] initWithFrame:CGRectMake(0, kh, scrollView.frame.size.width, -kh)];
    self.backView.backgroundColor = [UIColor colorWithRed:0 green:0 blue:0 alpha:0.2];
    [_scrollView addSubview:self.backView];

    self.label = [[UILabel alloc] initWithFrame:CGRectMake(0, -kh-40, scrollView.frame.size.width, 40)];
    self.label.text = @"⇣ 继续下拉刷新";
    self.label.font = [UIFont systemFontOfSize:12];
    self.label.textColor = [UIColor grayColor];
    self.label.textAlignment = 1;
    [self.backView addSubview:self.label];
    
    [self.scrollView addObserver:self forKeyPath:@"contentOffset" options:NSKeyValueObservingOptionNew|NSKeyValueObservingOptionOld context:NULL];
}

- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary<NSString *,id> *)change context:(void *)context {
    
    if ([keyPath isEqualToString:@"contentOffset"] && object == self.scrollView) {

        if (self.reload) {
            return;
        }
        CGPoint newPoint = [change[@"new"] CGPointValue];

        if (newPoint.y < -50.0) {

            if (self.scrollView.dragging) {
                // 正在拖动
                self.label.text = @"⇡ 松开即可刷新";
            }else{
                // 正在拖动
                self.label.text = @"⇡ 松开即可刷新";
                
                if (!self.reload) {
                    // 开始刷新
                    [self beginRefreshing];
                }else{
                    // 正在刷新
                }
            }
        }
        
        else if (newPoint.y > -50.0 && newPoint.y < 0.0) {
            self.label.text = self.reloadString;
        }
        else{
            self.label.text = self.reloadString;
            self.reload = NO;
        }
    }
}

- (void)endRefreshing {
    
    self.reload = NO;
    self.reloadString = @"加载完成!";
    self.label.text = self.reloadString;
    @weakify(self);
    [UIView animateWithDuration:0.3 animations:^{
        @strongify(self);
        self.scrollView.contentOffset = CGPointMake(0, 0);
    } completion:^(BOOL finished) {
        @strongify(self);
        self.reloadString = @"⇣ 继续下拉刷新";
        self.reload = NO;
    }];
}

- (void)beginRefreshing {
    
    if (self.reload) {
        return;
    }
    @weakify(self);
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(0.001 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        @strongify(self);
        // 开始刷新
        self.reload = YES;
        self.label.text = @"正在加载中...";
        [UIView animateWithDuration:0.2 animations:^{
            @strongify(self);
            [self.scrollView setContentOffset:CGPointMake(0, -50) animated:YES];
        } completion:^(BOOL finished) {
            @strongify(self);
            if (self.beginRefreshingBlock) {
                self.beginRefreshingBlock(self.scrollView);
            }
        }];
    });
}
@end
